/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.007        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: crfilt.c           				    
 * Program name: crfilt						    
 * Source of file: written for PD use by Martin Houston             
 * Purpose: Filter for printers that cannot backspace (and therefore
 * print underlines etc).
 * Changes:                                                         
 ********************************************************************/

#include <stdio.h>

spaces(x)
int x;
{
    for(;x > 0;x--) putchar(' ');
}

main()
{
    int c;
    int cpos;

    for(cpos = 0; (c = getchar()) != EOF;)
    {
        if(c == '\b')
        {
            putchar('\r');
	    spaces(--cpos);  /* backspace 1 char */
        }
        else
        if((c == '\n') || (c == '\r') || (c == '\f'))
        {
            cpos = 0;
	    putchar(c);
        }
        else
        {
	    cpos++;
	    putchar(c);
        }
    }
}
